#ifndef __phasertng_table_sigesq_acentric_class__
#define __phasertng_table_sigesq_acentric_class__
#include <set>
#include <map>
#include <cassert>

namespace phasertng {
namespace table {

class sigesq_acentric
{
  // For acentrics, log(sigesq) as a function of log(expected info target) is
  // given below, with some exact values that are likely to be chosen filled in.
  private:
  std::map<double, double> logsigesqs;

  public:
  sigesq_acentric()
  {
    logsigesqs = {
      {-7.12959, 3.4012}, {-6.90017, 3.28642}, {-6.6708, 3.17164},
      {-6.44147, 3.05686}, {-6.2122, 2.94209}, {-5.983, 2.82731},
      {-5.7539, 2.71253}, {-5.52492, 2.59775}, {-5.29609, 2.48297},
      {-5.06744, 2.36819}, {-4.83904, 2.25342}, {-4.61094, 2.13864},
      {-4.38323, 2.02386}, {-4.156, 1.90908}, {-3.92941, 1.7943},
      {-3.70362, 1.67953}, {-3.47886, 1.56475}, {-3.25543, 1.44997},
      {-3.03371, 1.33519}, {-2.81418, 1.22041}, {-2.59743, 1.10564},
      {-2.38418, 0.990858}, {-2.1752, 0.87608}, {-1.97132, 0.761302},
      {-1.77336, 0.646524}, {-1.58204, 0.531746}, {-1.39798, 0.416968},
      {-1.22164, 0.30219}, {-1.05331, 0.187412}, {-0.893134, 0.0726338},
      {-0.741095, -0.0421442}, {-0.597066, -0.156922},  {-0.460823, -0.2717},
      {-0.332069, -0.386478}, {-0.210461, -0.501256},  {-0.0956214, -0.616034},
      {0.0128388, -0.730813}, {0.115314,  -0.845591}, {0.212192, -0.960369},
      {0.303849, -1.07515}, {0.390644,  -1.18992}, {0.472919, -1.3047},
      {0.550991, -1.41948}, {0.625159,  -1.53426}, {0.695699, -1.64904},
      {0.762868, -1.76382}, {0.826901,  -1.87859}, {0.888018, -1.99337},
      {0.946417, -2.10815}, {1.00228,  -2.22293}, {1.05579, -2.33771},
      {1.10708, -2.45248}, {1.15632,  -2.56726}, {1.20362, -2.68204},
      {1.24911, -2.79682}, {1.29291,  -2.9116}, {1.33511, -3.02637},
      {1.37582, -3.14115}, {1.41512,  -3.25593}, {1.45308, -3.37071},
      {1.4898, -3.48549}, {1.52534,  -3.60026}, {1.55975, -3.71504},
      {1.59312, -3.82982}, {1.62548,  -3.9446}, {1.6569, -4.05938},
      {1.68742, -4.17415}, {1.71708,  -4.28893}, {1.74594, -4.40371},
      {1.77402, -4.51849}, {1.80138,  -4.63327}, {1.82803, -4.74804},
      {1.85402, -4.86282}, {1.87937,  -4.9776}, {1.90411, -5.09238},
      {1.92827, -5.20716}, {1.95188,  -5.32193}, {1.97806, -5.43671},
      {2.00032, -5.55149}, {2.02213,  -5.66627}, {2.04349, -5.78105},
      {2.06442, -5.89582}, {2.08495,  -6.0106}, {2.10508, -6.12538},
      {2.12482, -6.24016}, {2.1442,  -6.35494}, {2.16323, -6.46972},
      {2.18191, -6.58449}, {2.20026,  -6.69927}, {2.21829, -6.81405},
      {2.236, -6.92883}, {2.25342,  -7.04361}, {2.27055, -7.15838},
      {2.28739, -7.27316}, {2.30396,  -7.38794}, {2.32027, -7.50272},
      {2.33632, -7.6175}, {2.35212,  -7.73227}, {2.36768, -7.84705},
      {2.383, -7.96183}, {2.3981,  -8.07661}, {2.41297, -8.19139},
      {2.42763, -8.30616}, {2.44208,  -8.42094}, {2.45632, -8.53572},
      {2.47037, -8.6505}, {2.48422,  -8.76528}, {2.49789, -8.88005},
      {2.51137, -8.99483}, {2.52467,  -9.10961}, {2.53781, -9.22439},
      {2.55077, -9.33917}, {2.56356,  -9.45394}, {2.5762, -9.56872},
      {2.58868, -9.6835}, {2.60101,  -9.79828}, {2.61318, -9.91306},
      {2.62521, -10.0278}, {2.6371,  -10.1426}, {2.64885, -10.2574},
      {2.66046, -10.3722}, {2.67194,  -10.4869}, {2.68329, -10.6017},
      {2.69451, -10.7165}, {2.70561,  -10.8313}, {2.71659, -10.9461},
      {2.72744, -11.0608}, {2.73819,  -11.1756}, {2.74881, -11.2904},
      {2.75933, -11.4052}, {2.76973,  -11.5199}, {2.78003, -11.6347},
      {2.79023, -11.7495}, {2.80032,  -11.8643}, {2.81031, -11.9791},
      {2.8202, -12.0938}, {2.83, -12.2086},  {2.8397, -12.3234},
      {2.8493, -12.4382}, {2.85882, -12.553}, {2.86824,  -12.6677},
      {2.87758, -12.7825}, {2.88683, -12.8973}, {2.896,  -13.0121},
      {2.90509, -13.1268}, {2.91409, -13.2416}, {2.92301,  -13.3564},
      {2.93185, -13.4712}, {2.94062, -13.586}, {2.9493,  -13.7007},
      {2.95792, -13.8155}
    };

    std::pair<double,double> exact;
    exact.first = std::log(0.001), exact.second =  3.29021;
    logsigesqs.insert(exact);
    exact.first = std::log(0.005), exact.second = 2.48409;
    logsigesqs.insert(exact);
    exact.first = std::log(0.01), exact.second = 2.13573;
    logsigesqs.insert(exact);
    exact.first = std::log(0.05), exact.second = 1.31543;
    logsigesqs.insert(exact);
    exact.first = std::log(0.1), exact.second = 0.946348;
    logsigesqs.insert(exact);
    exact.first = std::log(0.5), exact.second = -0.0796596;
    logsigesqs.insert(exact);
    exact.first = std::log(1.), exact.second = -0.71688;
    logsigesqs.insert(exact);
  }

  double get(double info)
  {
    assert(info > 0);
    double loginfo = std::log(info);
    // First check for exact match
    for (auto item : logsigesqs)
      if (loginfo == item.first)
        return std::exp(item.second);
    // For very little information beyond table, use linear extrapolation formula
    if (loginfo <= logsigesqs.begin()->first)
    {
      double arg = std::min(-0.163651 - 0.500033 * loginfo,70.);
      return std::exp(arg);
    }
    // For very high information, cap sigesq to smallest value in table
    if (loginfo >= logsigesqs.rbegin()->first)
      return std::exp(logsigesqs.rbegin()->second);
    // Interpolate within table bounds
    double i1 = logsigesqs.begin()->first;
    double s1 = logsigesqs.begin()->second;
    double i2 = logsigesqs.begin()->first;
    double s2 = logsigesqs.begin()->second;
    for (auto item : logsigesqs)
    {
      if (loginfo < item.first)
      {
        i2 = item.first;
        s2 = item.second;
        break;
      }
      i1 = item.first;
      s1 = item.second;
    }
    double val(s1 + (loginfo-i1)*(s2-s1)/(i2-i1));
    return std::exp(val);
  }
};

}}
#endif
